%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 
% FI:PA171 - Digital Filters
%
% topic: Lifting scheme
% author: David Svoboda <svoboda@fi.muni.cz>
%         Masaryk University (c) 2019
% note: designed for Matlab
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% input signal
f = [ 5 3 9 2 0 4 9 2 ];

%-----------------------------------------
% Lifting scheme for Haar
%-----------------------------------------

% Get predict and update steps:
haar = liftwave('haar');
displs(haar);

% construct one lifting step:

% 1) split:
A = f(1:2:end)
D = f(2:2:end)

% 2) predict:
D = D + haar{1,2}*A

% 3) update:
A = A + haar{2,2}*D

% 4) normalization:
A = A*haar{3,1}
D = D*haar{3,2}

%-----------------------------------------
% Lifting scheme for Daubechies-2
%-----------------------------------------

% Get predict and update steps:
db2 = liftwave('db2');
displs(db2);

% See the script 'lift_db2.m' that performs the lifting scheme
% from wavelet family: Daubechies-2
[A,D] = lift_db2(f)

%-------------------------------------------------------------------------
% Task A: Implement inverse step:
%
%     function [f] = ilift_db2(A,D)
%-------------------------------------------------------------------------

%-------------------------------------------------------------------------
% Task B: Perform the sequence of the following commands:
%
% (1) open some grayscale image (e.g. 'erika')
% (2) choose your favorite decomposition approach (dwt2 or lwt2 or wavedec2) 
% (3) perform 4 levels of 2D decomposition using Haar wavelets
% (4) choose some threshold T
% (5) apply this T only to detail coefficients 
%     - those greater (their amplitude) than T will be kept unmodified, 
%     - those below T will be set to zero)
% (6) perform 4 levels of 2D reconstruction of modified coefficients
%     using the same family of wavelets you used for decomposition
% (7) check the difference between the original and the output image
% (8) change the family of wavelets you used (e.g. db4, sym2, coif4)
%     and try it again
%-------------------------------------------------------------------------