function [A,D] = lift_db2(f)
db2 = liftwave('db2');

% The commented parts of the expressions below match samples out of domain.
% Let us utilize the boundary condition that puts zeros in each position
% whose value is not defined.

% (1) split
A = f(1:2:end);
D = f(2:2:end);

% (2) the first predict
for k=1:length(D)
    D(k) = D(k) + db2{1,2} * A(k);
end

% (3) the first update
for k=1:length(A)-1
    A(k) = A(k) + db2{2,2}(2) * D(k) + db2{2,2}(1) * D(k+1);
end
A(end) = A(end) + db2{2,2}(2) * D(end);% + db2{2,2}(end+1) * D(end+1);

%(4) the second predict
for k=2:length(D)
    D(k) = D(k) + db2{3,2} * A(k-1);
end
D(1) = D(1);% + db2{3,2} * A(0);

% (5) normalization
A = A * db2{4,1};
D = D * db2{4,2};

end
